package grobs;

import grobs.DynamicGrob.State;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.awt.geom.Area;

/**
 * <p>Title: Turtle World</p>
 * <p>Description: Turtle graphics</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Theodore Norvell
 * @version 1.0
 */

public class ShapeGrob extends DynamicGrob {
	protected Shape shape ;
	protected AffineTransform transform = AffineTransform.getTranslateInstance(0, 0);

    public ShapeGrob( Shape shape ) {
        this.shape = shape ;
    }
    
    protected Area area() {
        return new Area(shape).createTransformedArea(transform) ;
    }


    public void paint( Graphics2D g ) {
    	monitor.enter(); 
    	try {
    		Area area = area() ;
    		if( fillColor != null )  {
    			g.setColor( fillColor ) ;
    			g.fill( area ) ; } 
    		g.setColor(outlineColor) ;
    		g.draw( area ) ;}
    	finally{
    		monitor.leave() ;
    	}
    }

    public Shape getShape() {
    	return area() ;
    }
    
    protected void updateHook( State newState ) {
    	Double x = newState.position.x ;
    	Double y = newState.position.y ;
    	transform = AffineTransform.getTranslateInstance(x, y) ;
    }
}