package turtleWorld;

import grobs.GrobArena;
import monitor.AbstractMonitor;

public abstract class Controller extends AbstractMonitor {

	protected GrobArena arena;

	public abstract String[] startUp();

	public abstract String[] checkBoxes();

	public abstract String[] buttons();
	
	public abstract String controllerName();

	protected Log log;
	protected ThreadCounter threadCounter;

	public Controller(GrobArena arena, Log log, ThreadCounter threadCounter ) {
		super();
        this.arena = arena ;
        this.log = log ;
        this.threadCounter = threadCounter ;
	}
	
	public void enter() { super.enter() ; }
	
	public void leave() { super.leave() ; }

	public ThreadCounter threadCounter() { return threadCounter ; }

	/** Do nothing for approximately t seconds.
	 * While the thread does nothing, other threads are
	 * allowed to execute within the  */
	protected void pause(double t) {
	    leave();
	    try {
	    	if( t <= 0 ) return ; // Note: Will enter first
	        Thread.sleep( (long)( 1000 * t ) ) ; }
	    catch( InterruptedException e ) { }
	    finally {
	        enter() ; }
	}

}