package turtleWorld;

import java.util.*;

import javax.swing.JLabel;

class ThreadCounter {

	private AbstractList<String> commands = new ArrayList<String>() ;
	private JLabel statusBar;

	ThreadCounter( JLabel statusBar ) {
		this.statusBar = statusBar ;
	}

	synchronized void increment(String name) {
		commands.add(name);
		updateStatus() ; }

	synchronized void decrement(String name) {
		commands.remove(name) ;
		updateStatus() ; }

	private void updateStatus() {
		String statusString = "Active commands:" ;
		for( Iterator<String> it=commands.iterator() ; it.hasNext() ; ) {
			statusString += " " + it.next() ; }
		statusBar.setText( statusString ); }
}
